> For the complete documentation index, see [llms.txt](https://docs.truecaller.com/truecaller-for-business/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.truecaller.com/truecaller-for-business/verified-campaigns/api-webhook-documentation/webhook-events/event-types.md).

# Event Types

{% hint style="info" %}
We support Detailed Events (Impressions and Clicks) and Click events via webhooks. Each event has its resources that can be referred from the resource column.
{% endhint %}

#### Clickstream Webhook Event Structure

<table data-header-hidden><thead><tr><th width="185.29296875">Field Name</th><th width="138.87890625">Data Type</th><th width="451.4375">Description</th><th>Is PII</th></tr></thead><tbody><tr><td><strong>event_id</strong></td><td>UUID / String</td><td>Unique identifier for the user event. This groups all related actions for a single campaign interaction. To be generated from BE.</td><td>No</td></tr><tr><td><strong>reference_id</strong></td><td>String</td><td><p>Mapped as an external reference to a user phone number. Can be in following formats :</p><ul><li>The raw 12 digit phone number (with 2-digit country code) of the user who saw the campaign impression.</li><li>The SHA256 hashed value of the 12 digit phone number (with 2-digit country code) of the user who saw the campaign impression.</li><li>The reference_id of the user who saw the campaign impression; mapped to the optional reference_id field in the Payload Exchange API</li></ul></td><td>Yes</td></tr><tr><td><strong>organisation_id</strong></td><td>String</td><td>Identifier for the Organisation associated with the event.</td><td>No</td></tr><tr><td><strong>campaign_id</strong></td><td>String</td><td>Identifier for the campaign associated with the event.</td><td>No</td></tr><tr><td><strong>display_unit</strong></td><td>String</td><td>Identifier for the display unit where the event was served.</td><td>No</td></tr><tr><td><strong>impression_timestamp</strong></td><td>Timestamp</td><td>The exact date and time when the impression was served.</td><td>No</td></tr><tr><td><strong>click_timestamp</strong></td><td>Timestamp (Optional)</td><td>The exact date and time when the click event occurred. Only populated if a click happened.</td><td>No</td></tr><tr><td><strong>business_number</strong></td><td>String</td><td>The business phone number/sender id which triggered the campaign to the end user.</td><td>No</td></tr></tbody></table>

```json
// Event Structure for Clickstream - Detailed Events

{
    "event_id": "DfK910987654321SNJ",
    "reference_id": "911234567890",
    "organisation_id": "HHSDFZX1234592828SJ299",
    "campaign_id": "Test_campaign",
    "display_unit": "business-profile",
    "impression_timestamp": "1754116200",
    "click_timestamp": "1754118000",
    "business_number": "9122245644890"
}
```

```json
// Event Structure for Clickstream - Click Events

{
    "event_id": "DfK910987654321SNJ",
    "reference_id": "911234567890",
    "organisation_id": "HHSDFZX1234592828SJ299",
    "campaign_id": "Test_campaign",
    "display_unit": "business-profile",
    "impression_timestamp": "1754116200",
    "click_timestamp": "1754118000",
    "business_number": "9122245644890"
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.truecaller.com/truecaller-for-business/verified-campaigns/api-webhook-documentation/webhook-events/event-types.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
